using System.Diagnostics;
using System.Text;
using Microsoft.Web.WebView2.Core;

namespace EdgeVoyager
{
    public partial class Form1 : Form
    {
        int zoom = 100; 
        private HttpClient httpClient = new HttpClient();
        public Form1()
        {
            InitializeComponent();
            InitializeAsync();
        }

        private void CoreWebView2_NewWindowRequested(object sender, CoreWebView2NewWindowRequestedEventArgs e)
        {
            Form1 newForm = new Form1();
            newForm.webView21.Source = new Uri(e.Uri);
            newForm.Show();

            e.Handled = true;
        }

        async void InitializeAsync()
        {
            await webView21.EnsureCoreWebView2Async(null);
            webView21.CoreWebView2.WebResourceRequested += WebView2_WebResourceRequested;
            await webView21.CoreWebView2.ExecuteScriptAsync("window.onload=function(){window.chrome.webview.postMessage('100');};");
            webView21.CoreWebView2.Profile.PreferredColorScheme = CoreWebView2PreferredColorScheme.Light;
            webView21.CoreWebView2.NewWindowRequested += CoreWebView2_NewWindowRequested;
            if (Settings1.Default.firstwindow == true)
            {
                string htmlString = @"<!DOCTYPE html>
<html lang=""zh-CN"">
<head>
    <meta charset=""UTF-8"">
    <meta name=""viewport"" content=""width=device-width, initial-scale=1.0"">
    <title>ʼҳ</title>
    <style>
        body {
            margin: 0;
            padding: 0;
            background-image: url('https://bing.img.run/uhd.php'); 
            background-size: cover;
            background-repeat: no-repeat;
            background-attachment: fixed;
            font-family: Arial, sans-serif;
        }
        .header {
            background-color: rgba(255, 255, 255, 0.8);
            backdrop-filter: blur(10px);
            padding: 10px 20px;
            display: flex;
            align-items: center;
            position: relative;
            box-shadow: 0 2px 10px rgba(0, 0, 0, 0.1);
        }
        .logo {
            width: auto;
            height: auto;
        }
        .nav-item {
            margin-left: 20px;
            color: #333;
            text-decoration: none;
            font-size: 16px;
        }
        .nav-links {
            display: flex;
            align-items: center;
        }
        .welcome-text {
            text-align: center;
            margin: 20px 0;
            font-size: 36px;
            font-weight: bold;
            color: #0078D4;
        }
        .search-container {
            display: flex;
            justify-content: center;
            align-items: center;
            margin-top: 20px;
            border-radius: 15px;
            overflow: hidden;
        }
        .search-input {
            width: 70vw;
            max-width: 1000px;
            padding: 10px;
            font-size: 16px;
            border: none;
            border-radius: 15px 0 0 15px;
            height: 20px;
        }
        .search-button {
            padding: 10px 20px;
            width: 80px;
            font-size: 16px;
            cursor: pointer;
            border: none;
            background-color: #0078D4;
            color: white;
            border-radius: 0 15px 15px 0;
            height: 40px;
        }
        .search-engine-select {
            margin-left: 0px;
            padding: 10px;
            font-size: 16px;
            border: none;
            border-radius: 0px;
            background-color: #f2f2f2;
            cursor: pointer;
        }
        .acrylic-panel {
            background-color: rgba(255, 255, 255, 0.8);
            backdrop-filter: blur(10px);
            padding: 20px;
            border-radius: 8px;
            box-shadow: 0 4px 20px rgba(0, 0, 0, 0.2);
            margin: 20px 0;
            width: 90vw;
            margin-left: auto;
            margin-right: auto;
            max-width: 1200px;
        }
        @media (max-width: 600px) {
            .search-button {
                padding: 8px 16px;
            }
        }
    </style>
</head>
<body>
    <div class=""header"">
        <img src=""https://www.lykns.com.cn/wp-content/uploads/2025/01/pinwheel_48px.png"" alt=""Logo"" class=""logo"">
        <span style=""font-size: 24px; color: #333; margin-left: 0;"">LYKNS </span>
        <div class=""nav-links"">
            <a href=""https://www.lykns.com.cn"" class=""nav-item"">վ</a>
            <a href=""https://its.lykns.com.cn"" class=""nav-item"">Ʒ</a>
            <a href=""https://dev.lykns.com.cn"" class=""nav-item"">Git </a>
            <a href=""https://survey.lykns.com.cn"" class=""nav-item"">ʾϵͳ</a>
        </div>
    </div>
    <div class=""acrylic-panel"">
        <div style=""text-align:center;"">
            <?xml version=""1.0"" encoding=""utf-8""?>
            <svg xmlns=""http://www.w3.org/2000/svg"" viewBox=""0 0 48 48"" width=""128"" height=""128"">
              <linearGradient id=""_EnvA6UXZqPqJP5nSvD1Ka"" x1=""12.209"" x2=""34.197"" y1=""42.462"" y2=""7.83"" gradientTransform=""matrix(1 0 0 -1 0 47.89)"" gradientUnits=""userSpaceOnUse"">
                <stop offset=""0"" stop-color=""#737b80"" />
                <stop offset="".473"" stop-color=""#686f74"" />
                <stop offset=""1"" stop-color=""#575c61"" />
              </linearGradient>
              <path fill=""url(#_EnvA6UXZqPqJP5nSvD1Ka)"" d=""M44,24c0,11.044-8.956,20-20,20S4,35.044,4,24S12.956,4,24,4S44,12.956,44,24z"" />
              <linearGradient id=""_EnvA6UXZqPqJP5nSvD1Kb"" x1=""16.956"" x2=""31.044"" y1=""37.138"" y2=""10.642"" gradientTransform=""matrix(1 0 0 -1 0 47.89)"" gradientUnits=""userSpaceOnUse"">
                <stop offset=""0"" stop-color=""#ccc"" />
                <stop offset="".758"" stop-color=""#f2f2f2"" />
                <stop offset=""1"" stop-color=""#fff"" />
              </linearGradient>
              <path fill=""url(#_EnvA6UXZqPqJP5nSvD1Kb)"" d=""M39,24c0,8.287-6.713,15-15,15S9,32.287,9,24S15.713,9,24,9S39,15.713,39,24z"" />
              <linearGradient id=""_EnvA6UXZqPqJP5nSvD1Kc"" x1=""19.774"" x2=""28.226"" y1=""31.838"" y2=""15.942"" gradientTransform=""matrix(1 0 0 -1 0 47.89)"" gradientUnits=""userSpaceOnUse"">
                <stop offset=""0"" stop-color=""#21ad64"" />
                <stop offset=""1"" stop-color=""#088242"" />
              </linearGradient>
              <circle cx=""24"" cy=""24"" r=""9"" fill=""url(#_EnvA6UXZqPqJP5nSvD1Kc)"" />
            </svg>
        </div>
        <div class=""welcome-text"">
            ӭʹ LYKNS EdgeVoyager
        </div>
        <div class=""search-container"">
            <input type=""text"" id=""search-input"" class=""search-input"" placeholder=""..."">
            <select id=""search-engine-select"" class=""search-engine-select"">
                <option value=""bing"">Bing</option>
                <option value=""baidu"">ٶ</option>
                <option value=""google"">Google</option>
            </select>
            <button onclick=""search()"" class=""search-button""></button>
        </div>
    </div>
    <script>
        function search() {
            var query = document.getElementById('search-input').value;
            var engine = document.getElementById('search-engine-select').value;
            var url = '';
            if (engine === 'bing') {
                url = 'https://www.bing.com/search?q=' + encodeURIComponent(query);
            } else if (engine === 'baidu') {
                url = 'https://www.baidu.com/s?wd=' + encodeURIComponent(query);
            } else if (engine === 'google') {
                url = 'https://www.google.com/search?q=' + encodeURIComponent(query);
            }";

                webView21.CoreWebView2.NavigateToString(htmlString);
                Settings1.Default.firstwindow = false;
                Settings1.Default.Save();
            }
        }

        private void back_button_Click(object sender, EventArgs e)
        {
            webView21.CoreWebView2.GoBack();
        }

        private void forward_button_Click(object sender, EventArgs e)
        {
            webView21.CoreWebView2.GoForward();
        }

        private void refresh_button_Click(object sender, EventArgs e)
        {
            webView21.CoreWebView2.Reload();
        }

        private void stop_button_Click(object sender, EventArgs e)
        {
            webView21.CoreWebView2.Stop();
        }

        private void search_button_Click(object sender, EventArgs e)
        {
            if (textBox1.Text.Length > 0)
            {
                if (comboBox1.Text != "about:blank")
                {
                    Form1 newForm = new Form1();
                    newForm.webView21.Source = new Uri("https://cn.bing.com/search?q=" + textBox1.Text);
                    newForm.Show();
                }
                else
                {
                    webView21.CoreWebView2.Navigate("https://cn.bing.com/search?q=" + textBox1.Text);
                    webView21.CoreWebView2.Profile.PreferredColorScheme = CoreWebView2PreferredColorScheme.Light;
                }
            }
        }

        private void webView21_NavigationStarting(object sender, CoreWebView2NavigationStartingEventArgs e)
        {
            string currentUrl = webView21.Source.ToString();
            if (!comboBox1.Items.Contains(currentUrl))
            {
                comboBox1.Items.Add(currentUrl);
            }
            comboBox1.Text = currentUrl;
            progressBar.Value = 0;
            progressLabel.Text = "0%";
            StatusLabel.Text = "ʼ" + currentUrl;
        }

        private async void webView21_NavigationCompleted(object sender, CoreWebView2NavigationCompletedEventArgs e)
        {
            string currentUrl = webView21.Source.ToString();
            if (!comboBox1.Items.Contains(currentUrl))
            {
                comboBox1.Items.Add(currentUrl);
            }
            comboBox1.Text = currentUrl;
            progressBar.Value = 100;
            progressLabel.Text = "100%";
            StatusLabel.Text = "ɡ";
            string title = await webView21.CoreWebView2.ExecuteScriptAsync("document.title;");
            this.Text = "LYKNS EdgeVoyager" + title.Trim('"');

            string faviconUrl = await webView21.CoreWebView2.ExecuteScriptAsync("Array.from(document.querySelectorAll('link[rel=\"icon\"], link[rel=\"shortcut icon\"]')).map(link => link.href).find(url => url);");
            faviconUrl = faviconUrl.Trim('"');

            if (!string.IsNullOrEmpty(faviconUrl))
            {
                Uri uriResult;
                bool isAbsoluteUri = Uri.TryCreate(faviconUrl, UriKind.Absolute, out uriResult);

                if (isAbsoluteUri)
                {
                    using (var client = new HttpClient())
                    {

                        var faviconData = await client.GetByteArrayAsync(uriResult);
                        using (var ms = new MemoryStream(faviconData))
                        {
                            using (var img = Image.FromStream(ms))
                            {
                                if (img is Bitmap bitmap)
                                {
                                    this.Icon = Icon.FromHandle(bitmap.GetHicon());
                                }
                                else
                                {
                                    this.Icon = Icon.FromHandle(((Bitmap)img.Clone()).GetHicon());
                                }
                            }
                        }
                    }
                }
            }
        }

        private void comboBox1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                string url = comboBox1.Text;
                if (Uri.IsWellFormedUriString(url, UriKind.Absolute))
                {
                    webView21.CoreWebView2.Navigate(url);
                }
                else
                {
                    MessageBox.Show("Чַ", "", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
        }

        private void ˳XToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Environment.Exit(0);
        }

        private void webView21_ContentLoading(object sender, CoreWebView2ContentLoadingEventArgs e)
        {
            progressBar.Value = 50;
            progressLabel.Text = "50%";
            StatusLabel.Text = "ݿʼ";
        }
        private async void SetZoomLevel(double zoomLevel)
        {
            await webView21.CoreWebView2.ExecuteScriptAsync($"document.body.style.zoom = '{zoomLevel}%'");
        }

        private void toolStripSplitButton1_ButtonClick(object sender, EventArgs e)
        {
            SetZoomLevel(100);
            toolStripMenuItem3.Enabled = true;
        }

        private void toolStripMenuItem2_Click(object sender, EventArgs e)
        {
            zoom = zoom + 25;
            SetZoomLevel(zoom);
            toolStripMenuItem3.Enabled = true;
        }

        private void toolStripMenuItem3_Click(object sender, EventArgs e)
        {
            zoom = zoom - 25;
            SetZoomLevel(zoom);
            if (zoom == 25)
                toolStripMenuItem3.Enabled = false;
        }

        private void ˢRToolStripMenuItem_Click(object sender, EventArgs e)
        {
            webView21.CoreWebView2.Reload();
        }

        private void ֹͣTToolStripMenuItem_Click(object sender, EventArgs e)
        {
            webView21.CoreWebView2.Stop();
        }

        private void ǰQToolStripMenuItem_Click(object sender, EventArgs e)
        {
            webView21.CoreWebView2.GoForward();
        }

        private void WToolStripMenuItem_Click(object sender, EventArgs e)
        {
            webView21.CoreWebView2.GoBack();
        }

        private void webView21_SourceChanged(object sender, CoreWebView2SourceChangedEventArgs e)
        {
            StatusLabel.Text = "ԴַѸ";
        }

        private void WebView2_WebResourceRequested(object sender, CoreWebView2WebResourceRequestedEventArgs e)
        {
            string requestUri = e.Request.Uri;
            StatusLabel.Text = "Դ" + requestUri;
        }

        private void ToolStripMenuItem_CheckStateChanged(object sender, EventArgs e)
        {
            if (ToolStripMenuItem.Checked == true)
            {
                statusStrip1.Visible = true;
                webView21.Height = webView21.Height - 23;
            }
            else
            {
                statusStrip1.Visible = false;
                webView21.Height = webView21.Height + 23;
            }
        }

        private void EdgeVoyagerToolStripMenuItem_Click(object sender, EventArgs e)
        {
            AboutBox1 aboutBox1 = new AboutBox1();
            aboutBox1.ShowDialog();
        }

        private void ½NToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Settings1.Default.firstwindow = true;
            Settings1.Default.Save();
            Form1 newForm = new Form1();
            newForm.Show();
        }

        private void OToolStripMenuItem_Click(object sender, EventArgs e)
        {
            OpenFileDialog openFileDialog = new OpenFileDialog();
            openFileDialog.Filter = "ҳļ (*.html;*.htm)|*.html;*.htm|ʸͼļ (*.svg)|*.svg|ļ (*.*)|*.*";
            if (openFileDialog.ShowDialog() == DialogResult.OK)
            {
                string filePath = openFileDialog.FileName;
                Form1 newForm = new Form1();
                newForm.webView21.Source = new Uri("file:///" + filePath);
                newForm.Show();
            }
        }

        private async void SToolStripMenuItem_ClickAsync(object sender, EventArgs e)
        {
        }

        private async void ӡPToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string title = webView21.CoreWebView2.DocumentTitle;
            try
            {
                CoreWebView2PrintStatus printStatus = await webView21.CoreWebView2.PrintAsync(null);
                if (printStatus == CoreWebView2PrintStatus.Succeeded)
                {
                    MessageBox.Show(this, "ӡ " + title + " ĵӡɹ", "ӡĬϴӡ");
                }
                else if (printStatus == CoreWebView2PrintStatus.PrinterUnavailable)
                {
                    MessageBox.Show(this, "ӡã߻״̬", "ӡĬϴӡ");
                }
                else
                {
                    MessageBox.Show(this, "ӡ " + title + " ĵӡʧ", "ӡĬϴӡ");
                }
            }
            catch (Exception)
            {
                MessageBox.Show(this, "ӡ " + title + " ĵڽ", "ӡĬϴӡ");
            }
        }

        private void ӡԤVToolStripMenuItem_Click(object sender, EventArgs e)
        {
            webView21.CoreWebView2.ShowPrintUI();
        }

        private void SToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string mailtoLink = $"mailto:?subject=ҳ&body=鿴ҳ" + comboBox1.Text;
            Process.Start(new ProcessStartInfo
            {
                FileName = mailtoLink,
                UseShellExecute = true
            });
        }

        private async void PToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string title = webView21.CoreWebView2.DocumentTitle;
            string url = webView21.CoreWebView2.Source;

            // ȡҳַֽ
            string content = await GetWebPageContent(url);
            int charCount = content.Length;
            int byteCount = Encoding.UTF8.GetByteCount(content);

            // ȡҳı롢ԡ
            string encoding = "UTF-8"; // ĬֵʵҪӦͷлȡ
            string language = "zh-CN"; // ĬֵʵҪӦͷлȡ
            string contentType = "text/html"; // ĬֵʵҪӦͷлȡ

            // ȡҳԪ
            string author = await GetMetaData("author");
            string description = await GetMetaData("description");
            string keywords = await GetMetaData("keywords");
            string updateDate = await GetMetaData("last-modified");

            // ȡҳİȫϢ
            string securityInfo = await GetSecurityInfo(url);
            string securityLevel = "High"; // ĬֵʵҪݰȫ֤Ϣж

            // ȡҳϢ
            string faviconUrl = await GetFaviconUrl();
            string encodingLanguage = "HTML, JavaScript"; // ĬֵʵҪҳн

            // ʾҳ
            MessageBox.Show(
                $"Ϣ\n" +
                $"⣺{title}\n" +
                $"ַURL{url}\n" +
                $"룺{encoding}\n" +
                $"ԣ{language}\n" +
                $"ͣ{contentType}\n" +
                $"\nҳϢ\n" +
                $"ַ{charCount}\n" +
                $"ֽ{byteCount}\n" +
                $"뷽ʽHTML, XML\n" +
                $"\nҳԪݣ\n" +
                $"ߣ{author}\n" +
                $"{description}\n" +
                $"ؼʣ{keywords}\n" +
                $"ڣ{updateDate}\n" +
                $"\nҳȫϢ\n" +
                $"ȫ֤Ϣ{securityInfo}\n" +
                $"ȫ{securityLevel}\n" +
                $"\nϢ\n" +
                $"ղؼͼ꣺{faviconUrl}\n" +
                $"ԣ{encodingLanguage}",
                "ҳ",
                MessageBoxButtons.OK,
                MessageBoxIcon.Information
            );
        }

        private async Task<string> GetWebPageContent(string url)
        {
            try
            {
                HttpResponseMessage response = await httpClient.GetAsync(url);
                response.EnsureSuccessStatusCode();
                return await response.Content.ReadAsStringAsync();
            }
            catch (Exception ex)
            {
                return ex.Message;
            }
        }

        private async Task<string> GetMetaData(string name)
        {
            try
            {
                string script = $"document.querySelector('meta[name=\"{name}\"]').content;";
                return await webView21.CoreWebView2.ExecuteScriptAsync(script);
            }
            catch (Exception)
            {
                return "";
            }
        }

        private async Task<string> GetFaviconUrl()
        {
            try
            {
                string script = "Array.from(document.querySelectorAll('link[rel=\"icon\"], link[rel=\"shortcut icon\"]')).map(link => link.href).find(url => url);";
                string faviconUrl = await webView21.CoreWebView2.ExecuteScriptAsync(script);
                return faviconUrl.Trim('"');
            }
            catch (Exception)
            {
                return "";
            }
        }

        private async Task<string> GetSecurityInfo(string url)
        {
            try
            {
                HttpResponseMessage response = await httpClient.GetAsync(url);
                response.EnsureSuccessStatusCode();
                if (response.RequestMessage.RequestUri.Scheme == "https")
                {
                    var headers = response.Headers;
                    if (headers.Contains("Strict-Transport-Security"))
                    {
                        return "HSTSѿ";
                    }
                }
                return "HSTS";
            }
            catch (Exception ex)
            {
                return ex.Message;
            }
        }
    }
}
